<script>
	import Input from 'flowbite-svelte/Input.svelte';
	import { allowInputInt, allowInputIntString } from '$lib/utils';
	import Spinner from 'flowbite-svelte/Spinner.svelte';
	import { ErrorModal, ErrorMsg } from '$lib/stores';

	let isFetching = $state(false);
	let courseHeader = [
		'Course',
		'Section',
		'Faculty',
		'Time',
		'Room',
		'Semester',
		'Available Seat',
		'Edit or Delete'
	];

	let response = $state({});

	$effect(() => {
		response = null;
	});
</script>

<main>
	<aside class="w-min mx-auto surface-ios-cont rounded-md p-2.5 mb-6">
		<section class="flex w-min mx-auto gap-2">
			<Input
				id="admin-all-courses-input-course"
				oninput={allowInputIntString}
				defaultClass="surface-ios-comp"
				class="!rounded-md"
				size="sm"
				placeholder="Course"
			/>
			<Input
				id="admin-all-courses-input-faculty"
				oninput={allowInputIntString}
				defaultClass="surface-ios-comp"
				class="!rounded-md"
				size="sm"
				placeholder="Faculty"
			/>
			<Input
				id="admin-all-courses-input-section"
				defaultClass="surface-ios-comp"
				class="!rounded-md"
				size="sm"
				oninput={allowInputInt}
				type="number"
				placeholder="Section"
			/>
			<Input
				id="admin-all-courses-input-semester"
				defaultClass="surface-ios-comp"
				class="!rounded-md"
				size="sm"
				oninput={allowInputInt}
				type="number"
				placeholder="Semester"
			/>
			{#if isFetching}
				<div class="mx-4">
					<Spinner size={6} color="primary" />
				</div>
			{:else}
				<button
					onclick={() => {
						try {
							isFetching = true;
							let str = prompt('admin-all-courses-get-info');
							let res = JSON.parse(str);
							if (res.error === false) response = res.data;
							else {
								$ErrorMsg = 'Failed to get data';
								$ErrorModal = true;
								response = null;
							}
						} catch (err) {
							response = null;
							$ErrorMsg = 'Something went wrong';
							$ErrorModal = true;
						} finally {
							isFetching = false;
						}
					}}
					class="surface-ios-comp px-2 py-1 rounded-md flex justify-center items-center text-orange-500 dark:text-orange-400 font-semibold"
				>
					Search
				</button>
			{/if}
		</section>
	</aside>
	<section class="surface-ios-cont rounded-md p-2.5">
		<section class="overflow-x-auto w-full max-w-full surface-ios-comp rounded-md">
			<table class="w-full text-base table-auto border-collapse text-left">
				<thead class="bg-surface-ios-bg dark:bg-[#fff2]">
					<tr class="rounded">
						{#each courseHeader as header}
							<th class="px-2 py-1">{header}</th>
						{/each}
					</tr>
				</thead>
				{#if response && response?.courses?.length > 0}
					<tbody class="">
						{#each response?.courses as course}
							<tr
								class="rounded divide-x divide-surface-200 dark:divide-surface-400 hover:bg-surface-ios-bg hover:dark:bg-[#fff2] child:px-2 child:py-1"
							>
								{#each ['courseCode', 'section', 'faculty', 'time', 'room', 'semester'] as key}
									<td>{course[key]}</td>
								{/each}
								<td>{course.seats - course.students.length}</td>
								<td
									class="flex flex-row justify-start items-center gap-4 child:cursor-pointer child:font-semibold child:decoration-[1px] child:text-orange-500 child:dark:text-orange-400"
								>
									<button>Edit</button>
									<button>Delete</button>
								</td>
							</tr>
						{/each}
					</tbody>
				{/if}
			</table>
		</section>
	</section>
</main>
